      DOUBLE PRECISION FUNCTION SFG8D(X,IERR)
      INTEGER IX,IERR
      DOUBLE PRECISION SYS001,SYS039,SYS053,X,R1,R2,X1,Y,PSI,
     *                 ZERO,ONE,TEN
      DATA ZERO/0.0D0/,ONE/1.0D0/,TEN/10.0D0/,
     *     R1/0.008333333333333333D0/,R2/0.08333333333333333D0/
      DATA SYS001/3.1415932653589793D0/,SYS039/0.5772156649015329D0/,
     *     SYS053/1.7D308/
      IERR=0
      X1=X
      IX=IFIX(X)
      PSI=ZERO
      IF(X.NE.ZERO) GO TO 10
      PSI=-SYS039
      GO TO 50
   10 IF(X.GT.-ONE) GO TO 30
      IF(IX.NE.X) GO TO 20
      IERR=65
      PSI=SYS053
      GO TO 50
   20 X=-X-ONE
      PSI=SYS001*DCOS(SYS001*X)/DSIN(SYS001*X)
   30 IF(X.GE.TEN) GO TO 40
      X=X+ONE
      PSI=PSI-ONE/X
      GO TO 30
   40 Y=ONE/(X*X)
      PSI=PSI+DLOG(X)+0.5D0/X-((Y/252.0D0-R1)*Y+R2)*Y
   50 X=X1
      SFG8D=PSI
      RETURN
      END
